<template>
  <div class="book">
    <h1 class="book__title">Бронирования</h1>

    <div class="book__tabs">
      <button v-if="limitedActualBookings.length"
              type="button"
              class="book__tab"
              :class="{ 'book__tab--active': currentTab === 'actual' }"
              @click="currentTab !== 'actual' ? changeTab('actual') : null">
        Актуальные
      </button>
      <button v-if="limitedPastBookings.length"
              type="button"
              class="book__tab"
              :class="{ 'book__tab--active': currentTab === 'past' }"
              @click="currentTab !== 'past' ? changeTab('past') : null">
        Прошедшие
      </button>
    </div>

    <template v-if="currentTab === 'actual'">

      <div class="book__rooms">
        <div class="booked-room"
             :class="{ 'booked-room--active': isBookingActive(booking) }"
             v-for="booking in limitedActualBookings"
             :key="booking.id"
        >
          <div class="booked-room__img-wrapper">
            <nuxt-link :to="`/places/${booking.place.id}`" class="booked-room__img">
              <img :src="booking.place.images[0].url" :alt="booking.place.name">
            </nuxt-link>
            <!--<span class="booked-room__tag">Код&nbsp;—&nbsp;<b>452267</b></span>-->
          </div>

          <div class="booked-room__content">
            <nuxt-link :to="`/places/${booking.place.id}`" class="booked-room__name">{{ booking.place.name }}</nuxt-link>

            <div class="booked-room__info-wrapper">
              <div class="booked-room__info">
                <span class="booked-room__info-item">{{ booking.place.address }}</span>
                <span class="booked-room__info-item">Метро {{ booking.place.metro_station.name }}</span>
                <!--<span class="booked-room__info-item">+7 (905) 088-44-44</span>-->
              </div>
            </div>

            <div class="booked-room__btn-row">
              <span class="booked-room__time" v-html="getDateInfo(booking)"></span>
            </div>
          </div>
        </div>
      </div>

      <button v-if="(actualPage * roomsPerPage) < actualBookings.length"
              type="button"
              class="button button--gray book__show-more"
              @click="showMoreRooms">
        <icon-plus />
        Показать еще
      </button>

    </template>

    <template v-else-if="currentTab === 'past'">

      <div class="book__rooms">
        <div class="booked-room"
             v-for="booking in limitedPastBookings"
             :key="booking.id"
        >
          <div class="booked-room__img-wrapper">
            <nuxt-link :to="`/places/${booking.place.id}`" class="booked-room__img">
              <img :src="booking.place.images[0].url" :alt="booking.place.name">
            </nuxt-link>
            <!--<span class="booked-room__tag">Код&nbsp;—&nbsp;<b>452267</b></span>-->
          </div>

          <div class="booked-room__content">
            <nuxt-link :to="`/places/${booking.place.id}`" class="booked-room__name">{{ booking.place.name }}</nuxt-link>

            <div class="booked-room__info-wrapper">
              <div class="booked-room__info">
                <span class="booked-room__info-item">{{ booking.place.address }}</span>
                <span class="booked-room__info-item">Метро {{ booking.place.metro_station.name }}</span>
                <!--<span class="booked-room__info-item">+7 (905) 088-44-44</span>-->
              </div>
            </div>

            <div class="booked-room__btn-row">
              <span class="booked-room__time" v-html="getDateInfo(booking)"></span>
            </div>
          </div>
        </div>
      </div>

      <button v-if="(pastPage * roomsPerPage) < pastBookings.length"
              type="button"
              class="button button--gray book__show-more"
              @click="showMoreRooms">
        <icon-plus />
        Показать еще
      </button>

    </template>

    <template v-else>
      Ничего не найдено
    </template>

  </div>
</template>

<script>
  import IconPlus from '../../components/icons/IconPlus';

  import { getSeoBySlug, getUserBookings } from '../../service/deliroom-service';
  import { months, weekDays } from '../../assets/js/helpers/consts';

  export default {
    name: 'BookPage',
    components: {
      IconPlus
    },
    data: () => ({
      actualBookings: [],
      pastBookings: [],
      activeBooking: null,

      actualPage: 1,
      pastPage: 1,
      roomsPerPage: 6,

      currentTab: 'actual',

      weekDays: weekDays,
      months: months
    }),

    asyncData: async () => ({
      meta: await getSeoBySlug('/personal/bookings'),
    }),

    computed: {
      limitedActualBookings() {
        return this.actualBookings.filter((item, index) =>
          index < (this.roomsPerPage * this.actualPage))
      },

      limitedPastBookings() {
        return this.pastBookings.filter((item, index) =>
          index < (this.roomsPerPage * this.pastPage))
      }
    },

    async mounted() {
      const timer = setInterval(async () => {
        if (!this.$store.state.auth.tokenRefreshing) {
          clearInterval(timer);

          const bookings = await getUserBookings();

          bookings.data.forEach((booking) => {
            const currentDate = new Date();

            if (new Date(booking.end) < currentDate) {
              this.pastBookings.push(booking);
            } else {
              this.actualBookings.push(booking);
            }
          });

          this.actualBookings.sort((a, b) => {
            if (a.start < b.start) {
              return -1;
            }

            if (a.start > b.start) {
              return 1;
            }

            return 0;
          });

          if (this.limitedActualBookings.length) {
            this.currentTab = 'actual'
          } else if (this.limitedPastBookings.length) {
            this.currentTab = 'past'
          } else {
            this.currentTab = 'nothing'
          }
        }
      }, 100)
    },

    methods: {
      changeTab(tabName) {
        this.currentTab = tabName
      },

      showMoreRooms() {
        if (this.currentTab === 'actual') {
          this.actualPage += 1;
        } else {
          this.pastPage += 1;
        }
      },

      getDateInfo(booking) {
        const startISODateStr = booking.start_local.toString();
        const endISODateStr = booking.end_local.toString();

        const startISODate = new Date(startISODateStr.substr(0, 10));

        const getTimeLabel = (date) => date.substr(11, 5);

        return `${this.weekDays[startISODate.getDay()].short} ${startISODate.getDate()} ${this.months[startISODate.getMonth()]},&nbsp;
                <b>${getTimeLabel(startISODateStr)}&ndash;${getTimeLabel(endISODateStr)}</b>`
      },

      isBookingActive(booking) {
        const startDate = new Date(booking.start);
        const endDate = new Date(booking.end);
        const currentDate = new Date();

        return startDate < currentDate && currentDate < endDate;
      },
    },

    head() {
      if (!this.meta) return;

      return {
        title: this.meta.title,
        meta: this.meta.meta.map((metaItem) => ({
          ...metaItem,
          hid: metaItem.name.toLowerCase(),
          name: metaItem.name.toLowerCase(),
        })),
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .book {
    &__title {
      @include h2;

      margin-bottom: rem(50);

      @media (max-width: $mobile-width) {
        margin-bottom: rem(30);
      }
    }

    &__tabs {
      display: flex;
      align-items: center;
    }

    &__tab {
      @include btn-reset;
      @include p1;

      color: $dark-gray;
      cursor: pointer;

      &:hover {
        color: $green;
      }

      & + & {
        margin-left: rem(50);
      }

      &--active {
        color: $green;
        cursor: initial;
      }
    }

    &__show-more {
      height: rem(60);
      padding: 0 rem(36) 0 rem(28);

      svg {
        width: rem(12);
        height: rem(12);

        margin-right: rem(10);
      }

      @media (max-width: $mobile-width) {
        margin-top: rem(40);
      }
    }
  }


  .booked-room {
    display: flex;
    padding: rem(40) 0;

    @media (max-width: $mobile-width) {
      flex-flow: column;

      &:last-child {
        padding-bottom: 0
      }
    }

    &:not(:last-child) {
      border-bottom: rem(1) solid #DCE2EF;
    }

    &--active {
      &:not(:last-child) {
        border-color: $green;
      }

      .booked-room__time {
        @include green-btn;

        color: $white;

        b {
          color: inherit;
        }
      }

    }

    &__img-wrapper {
      flex: 0 0 rem(256);
      width: rem(256);

      @media (max-width: $mobile-width) {
        flex: auto;
        width: 100%;
      }
    }

    &__img {
      display: block;
      width: 100%;
      height: rem(146);

      border-radius: rem(4);
      overflow: hidden;

      @media (max-width: $mobile-width) {
        height: rem(220);
      }

      img {
        width: 100%;
        height: 100%;

        object-fit: cover;
      }
    }

    &__content {
      flex: 1 1;
      margin-left: rem(30);
      padding-top: rem(16);

      @media (max-width: $mobile-width) {
        flex: auto;
        margin-left: 0;
        padding-top: 0;
        margin-top: rem(24);
      }
    }

    &__name {
      @include p1;

      display: inline-flex;
      margin-bottom: rem(6);

      &:hover {
        color: $green;
      }
    }

    &__btns {
      display: flex;
      align-items: center;
    }

    &__time {
      @include gray-btn;
      @include bold-black-link;

      display: inline-flex;
      align-items: center;
      height: rem(35);
      padding: 0 rem(16);

      color: rgba($black, .5);
      border-radius: rem(40);

      b {
        font-weight: inherit;
        color: $black;
      }
    }

    &__cancel {
      @include btn-reset;
      @include bold-black-link;

      margin-left: rem(30);

      color: rgba($black, .5);
      cursor: pointer;

      &:hover {
        color: $black;
      }
    }

    &__tag {
      @include room-card-tag;

      position: absolute;
      top: rem(16);
      left: rem(16);

      color: $dark-gray;

      b {
        font-weight: inherit;
        color: $black;
      }
    }

    &__info-wrapper {
      overflow: hidden;
    }

    &__info {
      @include breadcrumbs;

      margin-bottom: rem(20);
    }
  }

</style>

